diff --git a/include/flecs/private/switch_list.h b/include/flecs/private/switch_list.h
index 18889f45b..74377b75f 100644
--- a/include/flecs/private/switch_list.h
+++ b/include/flecs/private/switch_list.h
@@ -61,6 +61,10 @@ uint64_t ecs_switch_get(
     const ecs_switch_t *sw,
     int32_t element);
 
+FLECS_EXPORT
+ecs_vector_t* ecs_switch_values(
+    const ecs_switch_t *sw);    
+
 FLECS_EXPORT
 int32_t ecs_switch_first(
     const ecs_switch_t *sw,
diff --git a/src/query.c b/src/query.c
index 9790284ec..b09605a02 100644
--- a/src/query.c
+++ b/src/query.c
@@ -285,12 +285,11 @@ int32_t get_component_index(
         /* If requested component is a case, find the corresponding switch to
          * lookup in the table */
         if (ECS_HAS_ROLE(component, CASE)) {
-            int32_t index = ecs_table_switch_from_case(
+            result = ecs_table_switch_from_case(
                 world, table, component);
-            ecs_assert(index != -1, ECS_INTERNAL_ERROR, NULL);
-
-            index += table->sw_column_offset;
+            ecs_assert(result != -1, ECS_INTERNAL_ERROR, NULL);
 
+            result += table->sw_column_offset;
         } else
         if (ECS_HAS_ROLE(component, TRAIT)) {
             ecs_assert(trait_index_offsets != NULL, ECS_INTERNAL_ERROR, NULL);
@@ -329,11 +328,15 @@ int32_t get_component_index(
 
             /* Check if component is a tag. If it is, set table_data to
             * zero, so that a system won't try to access the data */
-            const EcsComponent *data = ecs_get(
-                world, component, EcsComponent);
+            if (!ECS_HAS_ROLE(component, CASE) && 
+                !ECS_HAS_ROLE(component, SWITCH)) 
+            {
+                const EcsComponent *data = ecs_get(
+                    world, component, EcsComponent);
 
-            if (!data || !data->size) {
-                result = 0;
+                if (!data || !data->size) {
+                    result = 0;
+                }
             }
         }
         
diff --git a/src/switch_list.c b/src/switch_list.c
index e3818f853..0f5f5c207 100644
--- a/src/switch_list.c
+++ b/src/switch_list.c
@@ -10,7 +10,6 @@ ecs_switch_header_t *get_header(
     }
 
     uint64_t index = value - sw->min;
-    ecs_assert(index >= 0, ECS_INVALID_PARAMETER, NULL);
     return &sw->headers[index];
 }
 
@@ -228,6 +227,12 @@ uint64_t ecs_switch_get(
     return values[element];
 }
 
+ecs_vector_t* ecs_switch_values(
+    const ecs_switch_t *sw)
+{
+    return sw->values;
+}
+
 int32_t ecs_switch_first(
     const ecs_switch_t *sw,
     uint64_t value)
diff --git a/src/table.c b/src/table.c
index bd9b0a53b..44633a5e6 100644
--- a/src/table.c
+++ b/src/table.c
@@ -21,9 +21,17 @@ ecs_data_t* init_data(
 
     ecs_entity_t *entities = ecs_vector_first(type, ecs_entity_t);
 
-    if (count) {
+    if (count && !sw_count) {
         result->columns = ecs_os_calloc(ECS_SIZEOF(ecs_column_t) * count);    
+    } else if (count || sw_count) {
+        /* If a table has switch columns, store vector with the case values
+            * as a regular column, so it's easier to access for systems. To
+            * enable this, we need to allocate more space. */
+        int32_t type_count = ecs_vector_count(type);
+        result->columns = ecs_os_calloc(ECS_SIZEOF(ecs_column_t) * type_count);
+    }
 
+    if (count) {
         for (i = 0; i < count; i ++) {
             ecs_entity_t e = entities[i];
 
@@ -59,12 +67,17 @@ ecs_data_t* init_data(
             ecs_entity_t *sw_array = ecs_vector_first(sw_type, ecs_entity_t);
             int32_t sw_array_count = ecs_vector_count(sw_type);
 
-            result->sw_columns[i].data = ecs_switch_new(
+            ecs_switch_t *sw = ecs_switch_new(
                 sw_array[0], 
                 sw_array[sw_array_count - 1], 
                 0);
-
+            result->sw_columns[i].data = sw;
             result->sw_columns[i].type = sw_type;
+
+            int32_t column_id = i + table->sw_column_offset;
+            result->columns[column_id].data = ecs_switch_values(sw);
+            result->columns[column_id].size = sizeof(ecs_entity_t);
+            result->columns[column_id].alignment = ECS_ALIGNOF(ecs_entity_t);
         }
     }
 
@@ -694,7 +707,9 @@ int32_t ecs_table_append(
         }
 
         for (i = 0; i < sw_column_count; i ++) {
-            ecs_switch_add(sw_columns[i].data);
+            ecs_switch_t *sw = sw_columns[i].data;
+            ecs_switch_add(sw);
+            columns[i + table->sw_column_offset].data = ecs_switch_values(sw);
         }        
     }
 
